define(['dart_sdk', 'packages/stencil/stencil'], function(dart_sdk, stencil) {
  'use strict';
  const core = dart_sdk.core;
  const html = dart_sdk.html;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const stencil$ = stencil.stencil;
  const _root = Object.create(null);
  const main = Object.create(_root);
  const $setInnerHtml = dartx.setInnerHtml;
  let intToString = () => (intToString = dart.constFn(dart.fnType(core.String, [core.int])))();
  main.Movie = class Movie extends core.Object {
    get name() {
      return this[name$];
    }
    set name(value) {
      super.name = value;
    }
    get description() {
      return this[description$];
    }
    set description(value) {
      super.description = value;
    }
    get stars() {
      return this[stars$];
    }
    set stars(value) {
      super.stars = value;
    }
  };
  (main.Movie.new = function(name, description, stars) {
    this[name$] = name;
    this[description$] = description;
    this[stars$] = stars;
    if (dart.notNull(this.stars) < 0 || dart.notNull(this.stars) > 5) dart.throw(new core.ArgumentError.value(this.stars, "stars", "Must be between 0 and 5!"));
  }).prototype = main.Movie.prototype;
  dart.addTypeTests(main.Movie);
  const name$ = Symbol("Movie.name");
  const description$ = Symbol("Movie.description");
  const stars$ = Symbol("Movie.stars");
  dart.setFieldSignature(main.Movie, () => ({
    __proto__: dart.getFields(main.Movie.__proto__),
    name: dart.finalFieldType(core.String),
    description: dart.finalFieldType(core.String),
    stars: dart.finalFieldType(core.int)
  }));
  main.RatingComponent = class RatingComponent extends stencil$.Component {
    get stars() {
      return this[stars$0];
    }
    set stars(value) {
      super.stars = value;
    }
    render() {
      return "<div class=\"stars-holder\">\r\n  " + dart.str(this.until(this.stars, dart.fn(i => "<div class=\"star star-filled\">⭐</div>\n  ", intToString()))) + "\r\n  " + dart.str(this.until(5 - dart.notNull(this.stars), dart.fn(i => "<div class=\"star\">⭐</div>", intToString()))) + "\r\n</div>";
    }
  };
  (main.RatingComponent.new = function(stars) {
    this[stars$0] = stars;
  }).prototype = main.RatingComponent.prototype;
  dart.addTypeTests(main.RatingComponent);
  const stars$0 = Symbol("RatingComponent.stars");
  dart.setMethodSignature(main.RatingComponent, () => ({
    __proto__: dart.getMethods(main.RatingComponent.__proto__),
    render: dart.fnType(core.String, [])
  }));
  dart.setFieldSignature(main.RatingComponent, () => ({
    __proto__: dart.getFields(main.RatingComponent.__proto__),
    stars: dart.finalFieldType(core.int)
  }));
  main.MovieComponent = class MovieComponent extends stencil$.Component {
    get movie() {
      return this[movie$];
    }
    set movie(value) {
      super.movie = value;
    }
    render() {
      return "<div class=\"movie-card\">\r\n  <div class=\"movie-name\">" + dart.str(this.movie.name) + "</div>\r\n  <div class=\"movie-description\">" + dart.str(this.movie.description) + "</div>\r\n</div>    \r\n    ";
    }
  };
  (main.MovieComponent.new = function(movie) {
    this[movie$] = movie;
  }).prototype = main.MovieComponent.prototype;
  dart.addTypeTests(main.MovieComponent);
  const movie$ = Symbol("MovieComponent.movie");
  dart.setMethodSignature(main.MovieComponent, () => ({
    __proto__: dart.getMethods(main.MovieComponent.__proto__),
    render: dart.fnType(core.String, [])
  }));
  dart.setFieldSignature(main.MovieComponent, () => ({
    __proto__: dart.getFields(main.MovieComponent.__proto__),
    movie: dart.finalFieldType(main.Movie)
  }));
  main.MovieCardComponent = class MovieCardComponent extends stencil$.Component {
    get movie() {
      return this[movie$0];
    }
    set movie(value) {
      super.movie = value;
    }
    render() {
      return "<div class=\"movie-card\">\r\n  <div class=\"movie-name\">" + dart.str(this.movie.name) + "</div>\r\n  <div class=\"movie-description\">" + dart.str(this.movie.description) + "</div>\r\n  \r\n  " + dart.str(this.comp(new main.RatingComponent.new(this.movie.stars))) + "\r\n</div>    \r\n    ";
    }
  };
  (main.MovieCardComponent.new = function(movie) {
    this[movie$0] = movie;
  }).prototype = main.MovieCardComponent.prototype;
  dart.addTypeTests(main.MovieCardComponent);
  const movie$0 = Symbol("MovieCardComponent.movie");
  dart.setMethodSignature(main.MovieCardComponent, () => ({
    __proto__: dart.getMethods(main.MovieCardComponent.__proto__),
    render: dart.fnType(core.String, [])
  }));
  dart.setFieldSignature(main.MovieCardComponent, () => ({
    __proto__: dart.getFields(main.MovieCardComponent.__proto__),
    movie: dart.finalFieldType(main.Movie)
  }));
  main.main = function() {
    let castaway = new main.Movie.new("Cast away", "Obsessively punctual FedEx executive Chuck Noland (Tom Hanks) is en route to an assignment in Malaysia when his plane crashes over the Pacific Ocean during a storm.", 4);
    html.querySelector("#example-loop")[$setInnerHtml](new main.RatingComponent.new(4).render());
    html.querySelector("#example-data-binding")[$setInnerHtml](new main.MovieComponent.new(castaway).render());
    html.querySelector("#example-component")[$setInnerHtml](new main.MovieCardComponent.new(castaway).render());
  };
  dart.trackLibraries("web/main.ddc", {
    "main.dart": main
  }, '{"version":3,"sourceRoot":"","sources":["main.dart"],"names":[],"mappings":";;;;;;;;;;;;IAQe;;;;;;IAEA;;;;;;IAEH;;;;;;;6BAEJ,IAAS,EAAE,WAAgB,EAAE,KAAU;IAAlC,WAAI,GAAJ,IAAI;IAAO,kBAAW,GAAX,WAAW;IAAO,YAAK,GAAL,KAAK;AAC3C,QAAU,aAAN,UAAK,IAAG,KAAW,aAAN,UAAK,IAAG,GACvB,WAAM,IAAI,wBAAmB,CAAC,UAAK,EAAE,SAAS;EAClD;;;;;;;;;;;;IAKU;;;;;;;AAMR,YAAO,iDAEP,UAAK,CAAC,UAAK,EAAE,QAAC,CAAC,IAAK,sFACpB,UAAK,CAAC,AAAC,iBAAC,UAAK,GAAE,QAAC,CAAC,IAAK;IAExB;;uCATgB,KAAU;IAAL,aAAK,GAAL,KAAK;EAAC;;;;;;;;;;;;IAcf;;;;;;;AAMV,YAAO,yEAEiB,UAAK,KAAK,+DACH,UAAK,YAAY;IAGlD;;sCAVe,KAAU;IAAL,YAAK,GAAL,KAAK;EAAC;;;;;;;;;;;;IAed;;;;;;;AAMV,YAAO,yEAEiB,UAAK,KAAK,+DACH,UAAK,YAAY,oCAEhD,SAAI,CAAC,IAAI,wBAAe,CAAC,UAAK,MAAM;IAGtC;;0CAZmB,KAAU;IAAL,aAAK,GAAL,KAAK;EAAC;;;;;;;;;;;;AAgB9B,QAAY,WAAW,IAAI,cAAK,CAC5B,aACA,wKACA;AAEJ,sBAAa,CAAC,+BAA6B,KAAC,wBAAe,CAAC,SAAS;AACrE,sBAAa,CAAC,uCACG,KAAC,uBAAc,CAAC,QAAQ,QAAQ;AACjD,sBAAa,CAAC,oCACG,KAAC,2BAAkB,CAAC,QAAQ,QAAQ;EACvD","file":"main.ddc.js"}');
  // Exports:
  return {
    main: main
  };
});

//# sourceMappingURL=main.ddc.js.map
